Class Throwables

    • Method Detail

      • throwIfInstanceOf

        @GwtIncompatible
        public static <X extends Throwable> void throwIfInstanceOf​(Throwable throwable,
                                                                   Class<X> declaredType)
                                                            throws X extends Throwable
        Throws throwable if it is an instance of declaredType. Example usage:
         for (Foo foo : foos) {
           try {
             foo.bar();
           } catch (BarException | RuntimeException | Error t) {
             failure = t;
           }
         }
         if (failure != null) {
           throwIfInstanceOf(failure, BarException.class);
           throwIfUnchecked(failure);
           throw new AssertionError(failure);
         }
         
        Throws:
        X extends Throwable
        Since:
        20.0
      • throwIfUnchecked

        public static void throwIfUnchecked​(Throwable throwable)
        Throws throwable if it is a RuntimeException or Error. Example usage:
         for (Foo foo : foos) {
           try {
             foo.bar();
           } catch (RuntimeException | Error t) {
             failure = t;
           }
         }
         if (failure != null) {
           throwIfUnchecked(failure);
           throw new AssertionError(failure);
         }
         
        Since:
        20.0
      • propagateIfPossible

        @GwtIncompatible
        public static <X extends Throwable> void propagateIfPossible​(@CheckForNull
                                                                     Throwable throwable,
                                                                     Class<X> declaredType)
                                                              throws X extends Throwable
        Propagates throwable exactly as-is, if and only if it is an instance of RuntimeException, Error, or declaredType. Example usage:
         try {
           someMethodThatCouldThrowAnything();
         } catch (IKnowWhatToDoWithThisException e) {
           handle(e);
         } catch (Throwable t) {
           Throwables.propagateIfPossible(t, OtherException.class);
           throw new RuntimeException("unexpected", t);
         }
         
        Parameters:
        throwable - the Throwable to possibly propagate
        declaredType - the single checked exception type declared by the calling method
        Throws:
        X extends Throwable
      • propagate

        @CanIgnoreReturnValue
        @GwtIncompatible
        @Deprecated
        public static RuntimeException propagate​(Throwable throwable)
        Deprecated.
        Use throw e or throw new RuntimeException(e) directly, or use a combination of throwIfUnchecked(java.lang.Throwable) and throw new RuntimeException(e). For background on the deprecation, read Why we deprecated Throwables.propagate.
        Propagates throwable as-is if it is an instance of RuntimeException or Error, or else as a last resort, wraps it in a RuntimeException and then propagates.

        This method always throws an exception. The RuntimeException return type allows client code to signal to the compiler that statements after the call are unreachable. Example usage:

         T doSomething() {
           try {
             return someMethodThatCouldThrowAnything();
           } catch (IKnowWhatToDoWithThisException e) {
             return handle(e);
           } catch (Throwable t) {
             throw Throwables.propagate(t);
           }
         }
         
        Parameters:
        throwable - the Throwable to propagate
        Returns:
        nothing will ever be returned; this return type is only for your convenience, as illustrated in the example above
      • getRootCause

        public static Throwable getRootCause​(Throwable throwable)
        Returns the innermost cause of throwable. The first throwable in a chain provides context from when the error or exception was initially detected. Example usage:
         assertEquals("Unable to assign a customer id", Throwables.getRootCause(e).getMessage());
         
        Throws:
        IllegalArgumentException - if there is a loop in the causal chain
      • getCausalChain

        @Beta
        public static List<ThrowablegetCausalChain​(Throwable throwable)
        Gets a Throwable cause chain as a list. The first entry in the list will be throwable followed by its cause hierarchy. Note that this is a snapshot of the cause chain and will not reflect any subsequent changes to the cause chain.

        Here's an example of how it can be used to find specific types of exceptions in the cause chain:

         Iterables.filter(Throwables.getCausalChain(e), IOException.class));
         
        Parameters:
        throwable - the non-null Throwable to extract causes from
        Returns:
        an unmodifiable list containing the cause chain starting with throwable
        Throws:
        IllegalArgumentException - if there is a loop in the causal chain
      • getCauseAs

        @Beta
        @GwtIncompatible
        public static <X extends Throwable> X getCauseAs​(Throwable throwable,
                                                         Class<X> expectedCauseType)
        Returns throwable's cause, cast to expectedCauseType.

        Prefer this method instead of manually casting an exception's cause. For example, (IOException) e.getCause() throws a ClassCastException that discards the original exception e if the cause is not an IOException, but Throwables.getCauseAs(e, IOException.class) keeps e as the ClassCastException's cause.

        Throws:
        ClassCastException - if the cause cannot be cast to the expected type. The ClassCastException's cause is throwable.
        Since:
        22.0
      • lazyStackTrace

        @Beta
        @GwtIncompatible
        public static List<StackTraceElementlazyStackTrace​(Throwable throwable)
        Returns the stack trace of throwable, possibly providing slower iteration over the full trace but faster iteration over parts of the trace. Here, "slower" and "faster" are defined in comparison to the normal way to access the stack trace, throwable.getStackTrace(). Note, however, that this method's special implementation is not available for all platforms and configurations. If that implementation is unavailable, this method falls back to getStackTrace. Callers that require the special implementation can check its availability with lazyStackTraceIsLazy().

        The expected (but not guaranteed) performance of the special implementation differs from getStackTrace in one main way: The lazyStackTrace call itself returns quickly by delaying the per-stack-frame work until each element is accessed. Roughly speaking:

        • getStackTrace takes stackSize time to return but then negligible time to retrieve each element of the returned list.
        • lazyStackTrace takes negligible time to return but then 1/stackSize time to retrieve each element of the returned list (probably slightly more than 1/stackSize).

        Note: The special implementation does not respect calls to throwable.setStackTrace. Instead, it always reflects the original stack trace from the exception's creation.

        Since:
        19.0